import { render, unmountComponentAtNode } from "react-dom";
import SensorData from "../routes/SensorData";
import { screen } from "@testing-library/react";

let conteneur = null;
beforeEach(() => {
  // met en place un élément DOM comme cible de rendu
  conteneur = document.createElement("div");
  document.body.appendChild(conteneur);
});

afterEach(() => {
  // nettoie en sortie de test
  try {
    unmountComponentAtNode(conteneur);
  } catch (ignored) {}
  conteneur.remove();
  conteneur = null;
});

const interrupteur_off = JSON.parse(`{
  "id": 45678,
  "name": "Interrupteur cuisine",
  "type": "SWITCH",
  "data": {
      "value": 0
  }
}`);

it("Generation interrupteur off", () => {
  render(<SensorData sensor={interrupteur_off} />, conteneur);
  expect(screen.getByText("L'interrupteur est off")).toBeInTheDocument();
  expect(screen.getByAltText("Tourner off interrupteur")).toBeInTheDocument();
});

const interrupteur_on = JSON.parse(`{
    "id": 45678,
    "name": "Interrupteur cuisine",
    "type": "SWITCH",
    "data": {
        "value": 1
    }
}`);

it("Generation interrupteur on", () => {
  render(<SensorData sensor={interrupteur_on} />, conteneur);
  expect(screen.getByText("L'interrupteur est on")).toBeInTheDocument();
  expect(screen.getByAltText("Tourner on interrupteur")).toBeInTheDocument();
});

const lumiere_eteinte = JSON.parse(`{
  "id": 34561,
  "name": "Lumière salon",
  "type": "LIGHT",
  "data": {
      "value": 0
  }
}`);

it("Generation lumiere eteinte", () => {
  render(<SensorData sensor={lumiere_eteinte} />, conteneur);
  expect(screen.getByText("La lumière est off")).toBeInTheDocument();
  expect(screen.getByAltText("Tourner off ampoule")).toBeInTheDocument();
});

const lumiere_allumer = JSON.parse(`{
  "id": 34561,
  "name": "Lumière salon",
  "type": "LIGHT",
  "data": {
      "value": 50
  }
}`);
